<?php

declare(strict_types=1);

namespace A2G\A2gTravelBlog\Domain\Model;

use T3G\AgencyPack\Blog\Domain\Model\Author;
use A2G\A2gTravelBlog\Domain\Model\TravelMarker;
use TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy;

/**
 * This file is part of the "Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * TravelAuthor
 */
class TravelAuthor extends Author {
    
    
    /**
     * relMapMarker
     *
     * @var TravelMarker
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $relMapMarker = null;
    
    /**
     * Returns the relMapMarker
     *
     * @return TravelMarker $relMapMarker
     */
    public function getRelMapMarker() {
        if ($this->relMapMarker instanceof LazyLoadingProxy) {
            $this->relMapMarker = $this->relMapMarker->_loadRealInstance();
        }
        return $this->relMapMarker;
    }

    /**
     * Sets the relMapMarker
     *
     * @param TravelMarker $relMapMarker
     * @return void
     */
    public function setRelMapMarker(TravelMarker $relMapMarker) {
        $this->relMapMarker = $relMapMarker;
    }

}
