<?php

declare(strict_types=1);

namespace A2G\A2gTravelBlog\Domain\Model;

use A2G\A2gMaps\Domain\Model\Marker;
use A2G\A2gTravelBlog\Domain\Model\TravelAuthor;
use TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy;

/**
 * This file is part of the "Products" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2021 Raphael Martin <raphy.martin@gmail.com>, none
 */

/**
 * TravelMarker
 */
class TravelMarker extends Marker {
    
    
    /**
     * relTravelAuthor
     *
     * @var TravelAuthor
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $relTravelAuthor = null;
    
    /**
     * Returns the relTravelAuthor
     *
     * @return TravelAuthor $relTravelAuthor
     */
    public function getRelTravelAuthor() {
        if ($this->relTravelAuthor instanceof LazyLoadingProxy) {
            $this->relTravelAuthor = $this->relTravelAuthor->_loadRealInstance();
        }
        return $this->relTravelAuthor;
    }

    /**
     * Sets the relTravelAuthor
     *
     * @param TravelAuthor $relTravelAuthor
     * @return void
     */
    public function setRelTravelAuthor(TravelAuthor $relTravelAuthor) {
        $this->relTravelAuthor = $relTravelAuthor;
    }

}
